#include <cstdlib>
#include <cstdio>
   
#include "bam/bam.h"
#include "bam/sam.h"
 
int main(int argc, char *argv[]) {
 
  samfile_t *fp_in = NULL;
  bam1_t *b=NULL;

  fp_in = samopen(argv[1], "rb", 0);

  if(NULL == fp_in) {
     printf("Could not open file\n");
  }
 
  b = bam_init1();
  int pos=0;
  int lastpos=0;

  while(samread(fp_in, b) > 0) {
    lastpos = pos;
    pos = b->core.pos;
         
    if(pos != lastpos) {
      printf("tid  : %d\n",b->core.tid);
      printf("pos  : %d\n",b->core.pos);
      char *name  = bam1_qname(b);
      char *qual  = (char*)bam1_qual(b);

      int n=0;
      char *qseq = (char *) malloc(b->core.l_qseq+1);
      char *s   = (char*)bam1_seq(b);
      for(n=0;n<(b->core.l_qseq);n++) {
        char v = bam1_seqi(s,n);
        qseq[n] = bam_nt16_rev_table[v];
      }
      qseq[n] = 0;

      printf("name : %s\n",name);
      //print SAM text format of this BAM record:
      char * samtext=bam_format1(fp_in->header, b);
      printf("%s\n",samtext);
      
      printf("qseq : %s\n",qseq);
      //printf("s cigar: %s\n",cigar);
      
      printf("qual : ");
      for(n=0;n<(b->core.l_qseq);n++) {
        //printf(" %d",qual[n]);
        qseq[n]=qual[n]+33;        
        }
      qseq[n]=0;
      printf("%s\n",qseq);
    }
    bam_destroy1(b);
    b = bam_init1();
  }
  bam_destroy1(b);

  samclose(fp_in);
  return 0;
}
